解析PHP中Exception异常机制

作者在 2022-04-06 11:12:11 发布以下内容

这篇文章主要介绍了解析PHP中Exception异常机制,本文通过异常的基本使用和一些常用的异常使用案例来解析说明该项概念,以下就是详细内容,需要的朋友可以参考下

异常的基本使用

当异常被抛出时,其后的代码不会继续执行,PHP 会尝试查找匹配的 "catch" 代码块。
如果异常没有被捕获,而且又没用使用 set_exception_handler() 作相应的处理的话,那么将发生一个严重的错误(致命错误),并且输出 "Uncaught Exception" (未捕获异常)的错误消息。
让我们尝试抛出一个异常,同时不去捕获它:

<?php
//create function with an exception
function checkNum($number)
 {
 if($number>1)
  {
  throw new Exception("Value must be 1 or below");
  }
 return true;
 }
 
//trigger exception
checkNum(2);
?>
上面的代码会获得类似这样的一个错误:

PHP Fatal error:  Uncaught exception 'Exception' with message 'Value must be 1 or below' in /home/wangkongming/babytree/test/php/php_ob/3.php:7
Stack trace:
#0 /home/wangkongming/babytree/test/php/php_ob/3.php(12): checkNum(2)
#1 {main}
  thrown in /home/wangkongming/babytree/test/php/php_ob/3.php on line 7

Try, throw 和 catch

要避免上面例子出现的错误,我们需要创建适当的代码来处理异常。
正确的处理程序应当包括:
Try - 使用异常的函数应该位于 "try" 代码块内。如果没有触发异常,则代码将照常继续执行。但是如果异常被触发,会抛出一个异常。
Throw - 这里规定如何触发异常。每一个 "throw" 必须对应至少一个 "catch"
Catch - "catch" 代码块会捕获异常,并创建一个包含异常信息的对象
让我们触发一个异常:

<?php
//create function with an exception
function checkNum($number)
 {   
 if($number>1)
  {  
      throw new Exception("Value must be 1 or below");
  }  
 return true;
 }   
     
//trigger exception                                                                                                       
try{
    checkNum(2);
    echo "If you see this ,the number is 1 or below";
}catch(Exception $e) {
    echo 'Message: '.$e -> getMessage();
}
?> 

运行上面的代码:

Message: Value must be 1 or below

例子解释:

上面的代码抛出了一个异常,并捕获了它:
创建 checkNum() 函数。它检测数字是否大于 1。如果是,则抛出一个异常。
在 "try" 代码块中调用 checkNum() 函数。
checkNum() 函数中的异常被抛出
"catch" 代码块接收到该异常,并创建一个包含异常信息的对象 ($e)。
通过从这个 exception 对象调用 $e->getMessage(),输出来自该异常的错误消息
不过,为了遵循“每个 throw 必须对应一个 catch”的原则,可以设置一个顶层的异常处理器来处理漏掉的错误。

到此这篇关于解析PHP中Exception异常机制的文章就介绍到这了。


默认分类 | 阅读 972 次
文章评论,共0条
游客请输入验证码
浏览7089次
文章分类
文章归档
最新评论